package nc.ui.gl.accbook;

import java.awt.Color;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import nc.ui.gl.common.CompConsts;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UILabel;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.ValueChangedEvent;
import nc.ui.pub.beans.ValueChangedListener;
import nc.vo.pub.lang.UFDate;

public class DateChooser extends UIPanel implements ValueChangedListener {

   private UIRefPane ivjDateEnd = null;
   private UIRefPane ivjDateStart = null;
   private JLabel ivjJLabel1 = null;
   private UILabel ivjLabel = null;
   private ClientEnvironment env = null;


   public DateChooser() {
      this.initialize();
   }

   public DateChooser(LayoutManager p0) {
      super(p0);
   }

   public DateChooser(LayoutManager p0, boolean p1) {
      super(p0, p1);
   }

   public DateChooser(boolean p0) {
      super(p0);
   }

   private UIRefPane getDateEnd() {
      if(this.ivjDateEnd == null) {
         try {
            this.ivjDateEnd = new UIRefPane();
            this.ivjDateEnd.setName("DateEnd");
            this.ivjDateEnd.setBounds(CompConsts.getXByBefore(this.getJLabel1(), 0), this.getJLabel1().getY(), CompConsts.getYmdWidth(), CompConsts.getTextHeight());
            this.ivjDateEnd.setRefNodeName("日历");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjDateEnd;
   }

   private UIRefPane getDateStart() {
      if(this.ivjDateStart == null) {
         try {
            this.ivjDateStart = new UIRefPane();
            this.ivjDateStart.setName("DateStart");
            this.ivjDateStart.setBounds(CompConsts.getXByBefore(this.getLabel(), 0), this.getLabel().getY(), CompConsts.getYmdWidth(), CompConsts.getTextHeight());
            this.ivjDateStart.setRefNodeName("日历");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjDateStart;
   }

   public String getEndDate() {
      return this.getDateEnd().getRefCode();
   }

   private JLabel getJLabel1() {
      if(this.ivjJLabel1 == null) {
         try {
            this.ivjJLabel1 = new JLabel();
            this.ivjJLabel1.setName("JLabel1");
            this.ivjJLabel1.setText("~");
            this.ivjJLabel1.setBounds(CompConsts.getXByBefore(this.getDateStart(), 0), this.getDateStart().getY(), CompConsts.getToCharWidth(), CompConsts.getTextHeight());
            this.ivjJLabel1.setForeground(Color.black);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjJLabel1;
   }

   private UILabel getLabel() {
      if(this.ivjLabel == null) {
         try {
            this.ivjLabel = new UILabel();
            this.ivjLabel.setName("Label");
            this.ivjLabel.setText(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000071"));
            this.ivjLabel.setBoundsAutoSize(0, 0);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjLabel;
   }

   public String getStartDate() {
      return this.getDateStart().getRefCode();
   }

   private void handleException(Throwable exception) {
   }

   private void initialize() {
      try {
         this.setName("DateChooser");
         this.setLayout((LayoutManager)null);
         this.add(this.getLabel(), this.getLabel().getName());
         this.add(this.getDateStart(), this.getDateStart().getName());
         this.add(this.getJLabel1(), this.getJLabel1().getName());
         this.add(this.getDateEnd(), this.getDateEnd().getName());
         this.setSize(this.getDateEnd().getX() + this.getDateEnd().getWidth(), this.getDateEnd().getY() + this.getDateEnd().getHeight());
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.getDateEnd().addValueChangedListener(this);
      this.getDateStart().addValueChangedListener(this);
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         DateChooser aDateChooser = new DateChooser();
         exception.setContentPane(aDateChooser);
         exception.setSize(aDateChooser.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void setClientEnv(ClientEnvironment p_env) {
      this.env = p_env;
   }

   public void setEnabled(boolean isEnabled) {
      super.setEnabled(isEnabled);
      this.getDateEnd().setEnabled(isEnabled);
      this.getDateStart().setEnabled(isEnabled);
   }

   public void setEndDate(UFDate date) {
      this.getDateEnd().setText(date.toString());
   }

   public void setStartDate(UFDate date) {
      this.getDateStart().setText(date.toString());
   }

   public void valueChanged(ValueChangedEvent event) {
      if(event.getSource() == this.getDateEnd() && !this.getDateEnd().getRefCode().trim().equals("") && this.getDateStart().getRefCode().compareTo(this.getDateEnd().getRefCode()) > 0) {
         this.getDateStart().setText(this.getDateEnd().getRefCode());
      }

      if(event.getSource() == this.getDateStart() && this.getDateEnd().getRefCode().compareTo(this.getDateStart().getRefCode()) < 0) {
         this.getDateEnd().setText(this.getDateStart().getRefCode());
      }

   }
}
